
# define TOKEN char
# define VALUE char*
# define STACKTOKENS 1
# define STACKSIZE 2048

# include "cc.h"
# include "preccx.h"
# undef UNSETNAME
# include "preamble.h"

/* in order to be able to parse .. = <'>'>   !! */
/*                          or  .. = >'<'<      */
# define RIGHT_ANGLE_BRACKET '>'
# define LEFT_ANGLE_BRACKET '<'
/* and use  .. = <RIGHT_ANGLE_BRACKET> instead */
/* or       .. = >LEFT_ANGLE_BRACKET< */

                /* -------- spaces ---------- */

static STATUS hid0(){
PREDICATE p_isspace;
return p_range0n(p_isspace,0);
}
static STATUS hid1 (){
PARSER hid0, COMMENT;
static STATUS p_tok;
p_tok = (TOPARSER hid0) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER COMMENT) ();
}
STATUS SPACE(){
PARSER hid1;
return((TOPARSER hid1)());
}

static VOID hid2(){
 VV(0)=""; 
}
static STATUS hid3(){
PARSER p_nothing0;ACTION hid2;
return p_attach0n(TOPARSER p_nothing0,0,hid2,0);
}
static STATUS hid4 (){
PARSER SOMESPACE, hid3;
static STATUS p_tok;
p_tok = (TOPARSER SOMESPACE) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid3) ();
}
STATUS WHITESPACE(){
PARSER hid4;
return((TOPARSER hid4)());
}

static VOID hid5(){
 VV(2) = V(1); 
}
static STATUS hid6(){
PARSER SPACE;ACTION hid5;
return p_attach0n(TOPARSER SPACE,0,hid5,0);
}
static STATUS hid7(){
PARSER hid6;
return p_many0n(TOPARSER hid6,0);
}
static STATUS hid8(){
PARSER SPACE, hid7;
static STATUS p_tok;
P_PAND((TOPARSER SPACE)(),(TOPARSER hid7)());
return p_tok;
}
STATUS SOMESPACE(){
PARSER hid8;
return((TOPARSER hid8)());
}

                /* -- simple identifiers ------ */

/* read character into the cbuff */
static STATUS hid9(){
PREDICATE p_isalpha;
return p_range0n(p_isalpha,0);
}
static VOID hid10(){
 VV(1) = putchar(T(1)); 
}
static STATUS hid11(){
PARSER hid9;ACTION hid10;
return p_attach0n(TOPARSER hid9,0,hid10,0);
}
STATUS alpha(){
PARSER hid11;
return((TOPARSER hid11)());
}

/* append characters to the cbuff */
static VOID hid12(){
 VV(2) = V(1); 
}
static STATUS hid13(){
PARSER alnum;ACTION hid12;
return p_attach0n(TOPARSER alnum,0,hid12,0);
}
static STATUS hid14(){
PARSER hid13, p_nothing0;
static STATUS p_tok;
P_PAND((TOPARSER hid13)(),(TOPARSER p_nothing0)());
return p_tok;
}
static STATUS hid15(){
PARSER hid14;
return p_many0n(TOPARSER hid14,0);
}
static STATUS hid16(){
PARSER alpha, hid15;
static STATUS p_tok;
P_PAND((TOPARSER alpha)(),(TOPARSER hid15)());
return p_tok;
}
STATUS IDENTIFIER(){
PARSER hid16;
return((TOPARSER hid16)());
}
  
static STATUS hid17(){
PREDICATE p_isdigit;
return p_range0n(p_isdigit,0);
}
static VOID hid18(){
 VV(1)=putchar(T(1)); 
}
static STATUS hid19(){
PARSER hid17;ACTION hid18;
return p_attach0n(TOPARSER hid17,0,hid18,0);
}
STATUS digit(){
PARSER hid19;
return((TOPARSER hid19)());
}

static STATUS hid20(){
PREDICATE p_isalnum;
return p_range0n(p_isalnum,0);
}
static VOID hid21(){
 VV(1)=putchar(T(1)); 
}
static STATUS hid22(){
PARSER hid20;ACTION hid21;
return p_attach0n(TOPARSER hid20,0,hid21,0);
}
STATUS alnum(){
PARSER hid22;
return((TOPARSER hid22)());
}

/* and these are absorbing */

static STATUS hid23(){
return p_exactly0('[');
}
STATUS OPENBRACKET(){
PARSER hid23;
return((TOPARSER hid23)());
}

static STATUS hid24(){
return p_exactly0(']');
}
STATUS CLOSEBRACKET(){
PARSER hid24;
return((TOPARSER hid24)());
}

static STATUS hid25(){
return p_exactly0('(');
}
STATUS OPENPAREN(){
PARSER hid25;
return((TOPARSER hid25)());
}

static STATUS hid26(){
return p_exactly0(')');
}
STATUS CLOSEPAREN(){
PARSER hid26;
return((TOPARSER hid26)());
}

static STATUS hid27(){
return p_exactly0('{');
}
STATUS OPENBRACE(){
PARSER hid27;
return((TOPARSER hid27)());
}

static STATUS hid28(){
return p_exactly0('}');
}
STATUS CLOSEBRACE(){
PARSER hid28;
return((TOPARSER hid28)());
}

static STATUS hid29(){
PARSER optmantissa, optexponent;
static STATUS p_tok;
P_PAND((TOPARSER optmantissa)(),(TOPARSER optexponent)());
return p_tok;
}
static STATUS hid30(){
PARSER integer, hid29;
static STATUS p_tok;
P_PAND((TOPARSER integer)(),(TOPARSER hid29)());
return p_tok;
}
static VOID hid31(){
 VV(3) = V(1); 
}
static STATUS hid32(){
PARSER hid30;ACTION hid31;
return p_attach0n(TOPARSER hid30,0,hid31,0);
}
STATUS NUMBER(){
PARSER hid32;
return((TOPARSER hid32)());
}

static VOID hid33(){
 VV(0)=""; 
}
static STATUS hid34(){
PARSER p_nothing0;ACTION hid33;
return p_attach0n(TOPARSER p_nothing0,0,hid33,0);
}
static STATUS hid35 (){
PARSER somedigits, hid34;
static STATUS p_tok;
p_tok = (TOPARSER somedigits) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid34) ();
}
STATUS digits(){
PARSER hid35;
return((TOPARSER hid35)());
}

static VOID hid36(){
 VV(0)=""; 
}
static STATUS hid37(){
PARSER p_nothing0;ACTION hid36;
return p_attach0n(TOPARSER p_nothing0,0,hid36,0);
}
static STATUS hid38 (){
PARSER sign, hid37;
static STATUS p_tok;
p_tok = (TOPARSER sign) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid37) ();
}
STATUS optsign(){
PARSER hid38;
return((TOPARSER hid38)());
}

static VOID hid39(){
 VV(2) = V(1); 
}
static STATUS hid40(){
PARSER digit;ACTION hid39;
return p_attach0n(TOPARSER digit,0,hid39,0);
}
static STATUS hid41(){
PARSER hid40;
return p_many0n(TOPARSER hid40,0);
}
static STATUS hid42(){
PARSER digit, hid41;
static STATUS p_tok;
P_PAND((TOPARSER digit)(),(TOPARSER hid41)());
return p_tok;
}
STATUS somedigits(){
PARSER hid42;
return((TOPARSER hid42)());
}

static STATUS hid43(){
return p_exactly0('-');
}
static STATUS hid44(){
return p_exactly0('+');
}
static STATUS hid45 (){
PARSER hid43, hid44;
static STATUS p_tok;
p_tok = (TOPARSER hid43) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid44) ();
}
static VOID hid46(){
 VV(1)=putchar(T(1)); 
}
static STATUS hid47(){
PARSER hid45;ACTION hid46;
return p_attach0n(TOPARSER hid45,0,hid46,0);
}
STATUS sign(){
PARSER hid47;
return((TOPARSER hid47)());
}

static VOID hid48(){
 VV(2) = V(1); 
}
static STATUS hid49(){
PARSER somedigits;ACTION hid48;
return p_attach0n(TOPARSER somedigits,0,hid48,0);
}
static STATUS hid50(){
PARSER hid49, p_nothing0;
static STATUS p_tok;
P_PAND((TOPARSER hid49)(),(TOPARSER p_nothing0)());
return p_tok;
}
static STATUS hid51(){
PARSER hid50;
return p_option0n(TOPARSER hid50,0);
}
static STATUS hid52(){
PARSER point, hid51;
static STATUS p_tok;
P_PAND((TOPARSER point)(),(TOPARSER hid51)());
return p_tok;
}
STATUS mantissa(){
PARSER hid52;
return((TOPARSER hid52)());
}

static VOID hid53(){
 VV(0)=""; 
}
static STATUS hid54(){
PARSER p_nothing0;ACTION hid53;
return p_attach0n(TOPARSER p_nothing0,0,hid53,0);
}
static STATUS hid55 (){
PARSER mantissa, hid54;
static STATUS p_tok;
p_tok = (TOPARSER mantissa) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid54) ();
}
STATUS optmantissa(){
PARSER hid55;
return((TOPARSER hid55)());
}

static STATUS hid56(){
return p_exactly0('.');
}
static VOID hid57(){
 VV(1)=putchar('.'); 
}
static STATUS hid58(){
PARSER hid56;ACTION hid57;
return p_attach0n(TOPARSER hid56,0,hid57,0);
}
STATUS point(){
PARSER hid58;
return((TOPARSER hid58)());
}

static STATUS hid59(){
return p_exactly0('e');
}
static STATUS hid60(){
return p_exactly0('E');
}
static STATUS hid61 (){
PARSER hid59, hid60;
static STATUS p_tok;
p_tok = (TOPARSER hid59) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid60) ();
}
static VOID hid62(){
 VV(1)=putchar(T(1)); 
}
static STATUS hid63(){
PARSER hid61;ACTION hid62;
return p_attach0n(TOPARSER hid61,0,hid62,0);
}
STATUS E(){
PARSER hid63;
return((TOPARSER hid63)());
}

static STATUS hid64(){
PARSER E, integer;
static STATUS p_tok;
P_PAND((TOPARSER E)(),(TOPARSER integer)());
return p_tok;
}
static VOID hid65(){
 VV(2) = V(1); 
}
static STATUS hid66(){
PARSER hid64;ACTION hid65;
return p_attach0n(TOPARSER hid64,0,hid65,0);
}
STATUS exponent(){
PARSER hid66;
return((TOPARSER hid66)());
}

static VOID hid67(){
 VV(0)=""; 
}
static STATUS hid68(){
PARSER p_nothing0;ACTION hid67;
return p_attach0n(TOPARSER p_nothing0,0,hid67,0);
}
static STATUS hid69 (){
PARSER exponent, hid68;
static STATUS p_tok;
p_tok = (TOPARSER exponent) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid68) ();
}
STATUS optexponent(){
PARSER hid69;
return((TOPARSER hid69)());
}

static STATUS hid70(){
return p_exactly0('\'');
}
static VOID hid71(){
 VV(1)=putchar('\''); 
}
static STATUS hid72(){
PARSER hid70;ACTION hid71;
return p_attach0n(TOPARSER hid70,0,hid71,0);
}
STATUS singlequote(){
PARSER hid72;
return((TOPARSER hid72)());
}

static STATUS hid73(){
return p_exactly0('\\');
}
STATUS escape(){
PARSER hid73;
return((TOPARSER hid73)());
}

STATUS ANYTHING(){
PARSER p_anything0;
return((TOPARSER p_anything0)());
}

static STATUS hid74(){
return p_notexactly0('\'');
}
STATUS notasinglequote(){
PARSER hid74;
return((TOPARSER hid74)());
}

static STATUS hid75(){
PARSER escape, ANYTHING;
static STATUS p_tok;
P_PAND((TOPARSER escape)(),(TOPARSER ANYTHING)());
return p_tok;
}
static VOID hid76(){
 VV(2)=V(1);putchar('\\');putchar(T(2)); 
}
static STATUS hid77(){
PARSER hid75;ACTION hid76;
return p_attach0n(TOPARSER hid75,0,hid76,0);
}
static STATUS hid78(){
PARSER hid77, p_nothing0;
static STATUS p_tok;
P_PAND((TOPARSER hid77)(),(TOPARSER p_nothing0)());
return p_tok;
}
static VOID hid79(){
 VV(1)=putchar(T(1));
}
static STATUS hid80(){
PARSER notasinglequote;ACTION hid79;
return p_attach0n(TOPARSER notasinglequote,0,hid79,0);
}
static STATUS hid81 (){
PARSER hid78, hid80;
static STATUS p_tok;
p_tok = (TOPARSER hid78) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid80) ();
}
STATUS chr(){
PARSER hid81;
return((TOPARSER hid81)());
}

static STATUS hid82(){
PARSER chr, singlequote;
static STATUS p_tok;
P_PAND((TOPARSER chr)(),(TOPARSER singlequote)());
return p_tok;
}
static STATUS hid83(){
PARSER singlequote, hid82;
static STATUS p_tok;
P_PAND((TOPARSER singlequote)(),(TOPARSER hid82)());
return p_tok;
}
static VOID hid84(){
 VV(3)=V(1); 
}
static STATUS hid85(){
PARSER hid83;ACTION hid84;
return p_attach0n(TOPARSER hid83,0,hid84,0);
}
STATUS CHARCONST(){
PARSER hid85;
return((TOPARSER hid85)());
}

static STATUS hid86(){
PARSER strchrs, doublequote;
static STATUS p_tok;
P_PAND((TOPARSER strchrs)(),(TOPARSER doublequote)());
return p_tok;
}
static STATUS hid87(){
PARSER doublequote, hid86;
static STATUS p_tok;
P_PAND((TOPARSER doublequote)(),(TOPARSER hid86)());
return p_tok;
}
static VOID hid88(){
 VV(3)=V(1); 
}
static STATUS hid89(){
PARSER hid87;ACTION hid88;
return p_attach0n(TOPARSER hid87,0,hid88,0);
}
STATUS STRING(){
PARSER hid89;
return((TOPARSER hid89)());
}

static STATUS hid90(){
return p_exactly0('\"');
}
static VOID hid91(){
 VV(1)=putchar('\"'); 
}
static STATUS hid92(){
PARSER hid90;ACTION hid91;
return p_attach0n(TOPARSER hid90,0,hid91,0);
}
STATUS doublequote(){
PARSER hid92;
return((TOPARSER hid92)());
}

static STATUS hid93(){
PARSER escape, ANYTHING;
static STATUS p_tok;
P_PAND((TOPARSER escape)(),(TOPARSER ANYTHING)());
return p_tok;
}
static VOID hid94(){
 VV(2) = V(1);putchar('\\');putchar(T(2)); 
}
static STATUS hid95(){
PARSER hid93;ACTION hid94;
return p_attach0n(TOPARSER hid93,0,hid94,0);
}
static STATUS hid96(){
PARSER hid95, p_nothing0;
static STATUS p_tok;
P_PAND((TOPARSER hid95)(),(TOPARSER p_nothing0)());
return p_tok;
}
static VOID hid97(){
 VV(1) = putchar(T(1)); 
}
static STATUS hid98(){
PARSER notadoublequote;ACTION hid97;
return p_attach0n(TOPARSER notadoublequote,0,hid97,0);
}
static STATUS hid99 (){
PARSER hid96, hid98;
static STATUS p_tok;
p_tok = (TOPARSER hid96) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid98) ();
}
STATUS strchar(){
PARSER hid99;
return((TOPARSER hid99)());
}

static STATUS hid100(){
return p_notexactly0('\"');
}
STATUS notadoublequote(){
PARSER hid100;
return((TOPARSER hid100)());
}

static VOID hid101(){
 VV(2)=V(1); 
}
static STATUS hid102(){
PARSER strchar;ACTION hid101;
return p_attach0n(TOPARSER strchar,0,hid101,0);
}
static STATUS hid103(){
PARSER hid102;
return p_many0n(TOPARSER hid102,0);
}
static STATUS hid104(){
PARSER strchar, hid103;
static STATUS p_tok;
P_PAND((TOPARSER strchar)(),(TOPARSER hid103)());
return p_tok;
}
static VOID hid105(){
 VV(0)=""; 
}
static STATUS hid106(){
PARSER p_nothing0;ACTION hid105;
return p_attach0n(TOPARSER p_nothing0,0,hid105,0);
}
static STATUS hid107 (){
PARSER hid104, hid106;
static STATUS p_tok;
p_tok = (TOPARSER hid104) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid106) ();
}
STATUS strchrs(){
PARSER hid107;
return((TOPARSER hid107)());
}

static STATUS hid108(){
return p_exactly0('\\');
}
STATUS BACKSLASH(){
PARSER hid108;
return((TOPARSER hid108)());
}

static STATUS hid109(){
return p_exactly0('$');
}
STATUS DOLLAR(){
PARSER hid109;
return((TOPARSER hid109)());
}

static STATUS hid110(){
return p_exactly0('^');
}
STATUS CARET(){
PARSER hid110;
return((TOPARSER hid110)());
}

static STATUS hid111(){
return p_exactly0('!');
}
STATUS PLING(){
PARSER hid111;
return((TOPARSER hid111)());
}

static STATUS hid112(){
return p_exactly0('+');
}
STATUS PLUS(){
PARSER hid112;
return((TOPARSER hid112)());
}

static STATUS hid113(){
return p_exactly0('$');
}
static STATUS hid114(){
return p_exactly0('$');
}
static STATUS hid115(){
PARSER hid113, hid114;
static STATUS p_tok;
P_PAND((TOPARSER hid113)(),(TOPARSER hid114)());
return p_tok;
}
static VOID hid116(){
VV(2)=putname("(TOVALUE p_1)");
}
static STATUS hid117(){
PARSER hid115;ACTION hid116;
return p_attach0n(TOPARSER hid115,0,hid116,0);
}
static STATUS hid118(){
PARSER hid117, p_nothing0;
static STATUS p_tok;
P_PAND((TOPARSER hid117)(),(TOPARSER p_nothing0)());
return p_tok;
}
static STATUS hid119(){
return p_exactly0('$');
}
static VOID hid120(){
putname("(TOVALUE )p_");                   /*putint((1+getcount())*PSTACKLENGTH/10); */                    
}
static STATUS hid121(){
PARSER hid119;ACTION hid120;
return p_attach0n(TOPARSER hid119,0,hid120,0);
}
static STATUS hid122(){
PARSER hid121, p_nothing0;
static STATUS p_tok;
P_PAND((TOPARSER hid121)(),(TOPARSER p_nothing0)());
return p_tok;
}
static STATUS hid123(){
PARSER hid122, integer;
static STATUS p_tok;
P_PAND((TOPARSER hid122)(),(TOPARSER integer)());
return p_tok;
}
static VOID hid124(){
VV(2)=V(2);putchar(')');
}
static STATUS hid125(){
PARSER hid123;ACTION hid124;
return p_attach0n(TOPARSER hid123,0,hid124,0);
}
static STATUS hid126(){
PARSER hid125, p_nothing0;
static STATUS p_tok;
P_PAND((TOPARSER hid125)(),(TOPARSER p_nothing0)());
return p_tok;
}
static STATUS hid127(){
return p_exactly0('$');
}
static VOID hid128(){
putname("(TOVALUE ");
}
static STATUS hid129(){
PARSER hid127;ACTION hid128;
return p_attach0n(TOPARSER hid127,0,hid128,0);
}
static STATUS hid130(){
PARSER hid129, IDENTIFIER;
static STATUS p_tok;
P_PAND((TOPARSER hid129)(),(TOPARSER IDENTIFIER)());
return p_tok;
}
static VOID hid131(){
VV(2)=putchar(')');
}
static STATUS hid132(){
PARSER hid130;ACTION hid131;
return p_attach0n(TOPARSER hid130,0,hid131,0);
}
static STATUS hid133 (){
PARSER hid126, hid132;
static STATUS p_tok;
p_tok = (TOPARSER hid126) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid132) ();
}
static STATUS hid134 (){
PARSER hid118, hid133;
static STATUS p_tok;
p_tok = (TOPARSER hid118) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid133) ();
}
STATUS DOLLARID(){
PARSER hid134;
return((TOPARSER hid134)());
}

static STATUS hid135(){
PARSER optsign, somedigits;
static STATUS p_tok;
P_PAND((TOPARSER optsign)(),(TOPARSER somedigits)());
return p_tok;
}
static VOID hid136(){
VV(2)=V(2);
}
static STATUS hid137(){
PARSER hid135;ACTION hid136;
return p_attach0n(TOPARSER hid135,0,hid136,0);
}
STATUS integer(){
PARSER hid137;
return((TOPARSER hid137)());
}

static STATUS hid138(){
return p_exactly0('+');
}
static STATUS hid139(){
return p_exactly0('-');
}
static STATUS hid140(){
return p_exactly0('*');
}
static STATUS hid141(){
return p_exactly0('/');
}
static STATUS hid142(){
return p_exactly0('%');
}
static STATUS hid143(){
return p_exactly0('&');
}
static STATUS hid144(){
return p_exactly0('|');
}
static STATUS hid145(){
return p_exactly0('!');
}
static STATUS hid146(){
return p_exactly0('=');
}
static STATUS hid147(){
return p_exactly0('<');
}
static STATUS hid148(){
return p_exactly0(RIGHT_ANGLE_BRACKET);
}
static STATUS hid149 (){
PARSER hid147, hid148;
static STATUS p_tok;
p_tok = (TOPARSER hid147) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid148) ();
}
static STATUS hid150 (){
PARSER hid146, hid149;
static STATUS p_tok;
p_tok = (TOPARSER hid146) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid149) ();
}
static STATUS hid151 (){
PARSER hid145, hid150;
static STATUS p_tok;
p_tok = (TOPARSER hid145) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid150) ();
}
static STATUS hid152 (){
PARSER hid144, hid151;
static STATUS p_tok;
p_tok = (TOPARSER hid144) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid151) ();
}
static STATUS hid153 (){
PARSER hid143, hid152;
static STATUS p_tok;
p_tok = (TOPARSER hid143) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid152) ();
}
static STATUS hid154 (){
PARSER hid142, hid153;
static STATUS p_tok;
p_tok = (TOPARSER hid142) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid153) ();
}
static STATUS hid155 (){
PARSER hid141, hid154;
static STATUS p_tok;
p_tok = (TOPARSER hid141) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid154) ();
}
static STATUS hid156 (){
PARSER hid140, hid155;
static STATUS p_tok;
p_tok = (TOPARSER hid140) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid155) ();
}
static STATUS hid157 (){
PARSER hid139, hid156;
static STATUS p_tok;
p_tok = (TOPARSER hid139) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid156) ();
}
static STATUS hid158 (){
PARSER hid138, hid157;
static STATUS p_tok;
p_tok = (TOPARSER hid138) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid157) ();
}
STATUS BINOPCHAR(){
PARSER hid158;
return((TOPARSER hid158)());
}

static STATUS hid159(){
return p_exactly0('+');
}
static STATUS hid160(){
return p_exactly0('+');
}
static STATUS hid161(){
PARSER hid159, hid160;
static STATUS p_tok;
P_PAND((TOPARSER hid159)(),(TOPARSER hid160)());
return p_tok;
}
STATUS PLUSPLUS(){
PARSER hid161;
return((TOPARSER hid161)());
}

static STATUS hid162(){
return p_exactly0('-');
}
static STATUS hid163(){
return p_exactly0('-');
}
static STATUS hid164(){
PARSER hid162, hid163;
static STATUS p_tok;
P_PAND((TOPARSER hid162)(),(TOPARSER hid163)());
return p_tok;
}
STATUS MINUSMINUS(){
PARSER hid164;
return((TOPARSER hid164)());
}

static STATUS hid165(){
return p_exactly0('+');
}
static STATUS hid166(){
return p_exactly0('-');
}
static STATUS hid167(){
return p_exactly0('&');
}
static STATUS hid168(){
return p_exactly0('*');
}
static STATUS hid169(){
return p_exactly0('!');
}
static STATUS hid170 (){
PARSER hid168, hid169;
static STATUS p_tok;
p_tok = (TOPARSER hid168) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid169) ();
}
static STATUS hid171 (){
PARSER hid167, hid170;
static STATUS p_tok;
p_tok = (TOPARSER hid167) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid170) ();
}
static STATUS hid172 (){
PARSER hid166, hid171;
static STATUS p_tok;
p_tok = (TOPARSER hid166) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid171) ();
}
static STATUS hid173 (){
PARSER hid165, hid172;
static STATUS p_tok;
p_tok = (TOPARSER hid165) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid172) ();
}
STATUS MONOPCHAR(){
PARSER hid173;
return((TOPARSER hid173)());
}

static STATUS hid174(){
return p_exactly0('<');
}
STATUS LEFTANGLEBRACKET(){
PARSER hid174;
return((TOPARSER hid174)());
}

static STATUS hid175(){
return p_exactly0(RIGHT_ANGLE_BRACKET);
}
STATUS RIGHTANGLEBRACKET(){
PARSER hid175;
return((TOPARSER hid175)());
}

static STATUS hid176(){
PARSER escape, ANYTHING;
static STATUS p_tok;
P_PAND((TOPARSER escape)(),(TOPARSER ANYTHING)());
return p_tok;
}
static VOID hid177(){
VV(2)=V(2);
}
static STATUS hid178(){
PARSER hid176;ACTION hid177;
return p_attach0n(TOPARSER hid176,0,hid177,0);
}
static STATUS hid179(){
PARSER hid178, p_nothing0;
static STATUS p_tok;
P_PAND((TOPARSER hid178)(),(TOPARSER p_nothing0)());
return p_tok;
}
static STATUS hid180(){
return p_notexactly0('>');
}
static STATUS hid181 (){
PARSER hid179, hid180;
static STATUS p_tok;
p_tok = (TOPARSER hid179) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid180) ();
}
STATUS NOTARIGHTANGLEBRACKET(){
PARSER hid181;
return((TOPARSER hid181)());
}

static STATUS hid182(){
PARSER escape, ANYTHING;
static STATUS p_tok;
P_PAND((TOPARSER escape)(),(TOPARSER ANYTHING)());
return p_tok;
}
static VOID hid183(){
VV(2)=V(2);
}
static STATUS hid184(){
PARSER hid182;ACTION hid183;
return p_attach0n(TOPARSER hid182,0,hid183,0);
}
static STATUS hid185(){
PARSER hid184, p_nothing0;
static STATUS p_tok;
P_PAND((TOPARSER hid184)(),(TOPARSER p_nothing0)());
return p_tok;
}
static STATUS hid186(){
return p_notexactly0(LEFT_ANGLE_BRACKET);
}
static STATUS hid187 (){
PARSER hid185, hid186;
static STATUS p_tok;
p_tok = (TOPARSER hid185) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid186) ();
}
STATUS NOTALEFTANGLEBRACKET(){
PARSER hid187;
return((TOPARSER hid187)());
}

static STATUS hid188(){
return p_exactly0('/');
}
STATUS SLASH(){
PARSER hid188;
return((TOPARSER hid188)());
}

static STATUS hid189(){
return p_exactly0('*');
}
STATUS STAR(){
PARSER hid189;
return((TOPARSER hid189)());
}

static STATUS hid190(){
return p_exactly0('@');
}
STATUS AT(){
PARSER hid190;
return((TOPARSER hid190)());
}

static STATUS hid191(){
return p_exactly0('=');
}
STATUS EQUALS(){
PARSER hid191;
return((TOPARSER hid191)());
}

static STATUS hid192(){
return p_notexactly0('@');
}
STATUS NOTANAT(){
PARSER hid192;
return((TOPARSER hid192)());
}

static STATUS hid193(){
return p_exactly0('|');
}
STATUS OR(){
PARSER hid193;
return((TOPARSER hid193)());
}

static STATUS hid194(){
return p_exactly0(':');
}
STATUS COLON(){
PARSER hid194;
return((TOPARSER hid194)());
}

static STATUS hid195 (){
PARSER COLON, p_last0;
static STATUS p_tok;
p_tok = (TOPARSER COLON) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER p_last0) ();
}
STATUS COLONorEOL(){
PARSER hid195;
return((TOPARSER hid195)());
}

static STATUS hid196(){
return p_exactly0(',');
}
STATUS COMMA(){
PARSER hid196;
return((TOPARSER hid196)());
}

static STATUS hid197(){
PARSER escape, ANYTHING;
static STATUS p_tok;
P_PAND((TOPARSER escape)(),(TOPARSER ANYTHING)());
return p_tok;
}
static VOID hid198(){
VV(2)=V(2);
}
static STATUS hid199(){
PARSER hid197;ACTION hid198;
return p_attach0n(TOPARSER hid197,0,hid198,0);
}
static STATUS hid200(){
PARSER hid199, p_nothing0;
static STATUS p_tok;
P_PAND((TOPARSER hid199)(),(TOPARSER p_nothing0)());
return p_tok;
}
static STATUS hid201(){
return p_notexactly0(':');
}
static STATUS hid202 (){
PARSER hid200, hid201;
static STATUS p_tok;
p_tok = (TOPARSER hid200) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid201) ();
}
STATUS NOTACOLON(){
PARSER hid202;
return((TOPARSER hid202)());
}

static STATUS hid203(){
return p_exactly0('?');
}
STATUS QUESTION(){
PARSER hid203;
return((TOPARSER hid203)());
}

static STATUS hid204(){
PARSER SLASH, STAR;
static STATUS p_tok;
P_PAND((TOPARSER SLASH)(),(TOPARSER STAR)());
return p_tok;
}
static VOID hid205(){
VV(2)=putname("/*");
}
static STATUS hid206(){
PARSER hid204;ACTION hid205;
return p_attach0n(TOPARSER hid204,0,hid205,0);
}
STATUS slashstar(){
PARSER hid206;
return((TOPARSER hid206)());
}

static STATUS hid207(){
PARSER STAR, SLASH;
static STATUS p_tok;
P_PAND((TOPARSER STAR)(),(TOPARSER SLASH)());
return p_tok;
}
static VOID hid208(){
VV(2)=putname("*/");
}
static STATUS hid209(){
PARSER hid207;ACTION hid208;
return p_attach0n(TOPARSER hid207,0,hid208,0);
}
STATUS starslash(){
PARSER hid209;
return((TOPARSER hid209)());
}

static VOID hid210(){
VV(2)=V(1);
}
static STATUS hid211(){
PARSER commentchr;ACTION hid210;
return p_attach0n(TOPARSER commentchr,0,hid210,0);
}
static STATUS hid212(){
PARSER hid211, p_nothing0;
static STATUS p_tok;
P_PAND((TOPARSER hid211)(),(TOPARSER p_nothing0)());
return p_tok;
}
static STATUS hid213(){
PARSER hid212;
return p_many0n(TOPARSER hid212,0);
}
static STATUS hid214(){
PARSER hid213, starslash;
static STATUS p_tok;
P_PAND((TOPARSER hid213)(),(TOPARSER starslash)());
return p_tok;
}
static STATUS hid215(){
PARSER slashstar, hid214;
static STATUS p_tok;
P_PAND((TOPARSER slashstar)(),(TOPARSER hid214)());
return p_tok;
}
static VOID hid216(){
VV(2)=V(1);
}
static STATUS hid217(){
PARSER hid215;ACTION hid216;
return p_attach0n(TOPARSER hid215,0,hid216,0);
}
STATUS COMMENT(){
PARSER hid217;
return((TOPARSER hid217)());
}

/* $!{foo} ought to try and recover at foo */

static VOID hid218(){
 VV(1) = putchar(T(1));
}
static STATUS hid219(){
PARSER NOTASTAR;ACTION hid218;
return p_attach0n(TOPARSER NOTASTAR,0,hid218,0);
}
static STATUS hid220(){
PARSER hid219, p_nothing0;
static STATUS p_tok;
P_PAND((TOPARSER hid219)(),(TOPARSER p_nothing0)());
return p_tok;
}
static VOID hid221(){
 VV(1) = putchar('\n');
}
static STATUS hid222(){
PARSER p_lastuniq0;ACTION hid221;
return p_attach0n(TOPARSER p_lastuniq0,0,hid221,0);
}
static STATUS hid223(){
PARSER hid222, p_nothing0;
static STATUS p_tok;
P_PAND((TOPARSER hid222)(),(TOPARSER p_nothing0)());
return p_tok;
}
static STATUS hid224(){
PARSER STAR, NOTASLASH;
static STATUS p_tok;
P_PAND((TOPARSER STAR)(),(TOPARSER NOTASLASH)());
return p_tok;
}
static VOID hid225(){
 VV(2) = (putchar('*'),putchar(T(2)));
}
static STATUS hid226(){
PARSER hid224;ACTION hid225;
return p_attach0n(TOPARSER hid224,0,hid225,0);
}
static STATUS hid227 (){
PARSER hid223, hid226;
static STATUS p_tok;
p_tok = (TOPARSER hid223) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid226) ();
}
static STATUS hid228 (){
PARSER hid220, hid227;
static STATUS p_tok;
p_tok = (TOPARSER hid220) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid227) ();
}
STATUS commentchr(){
PARSER hid228;
return((TOPARSER hid228)());
}

static STATUS hid229(){
return p_notexactly0('*');
}
STATUS NOTASTAR(){
PARSER hid229;
return((TOPARSER hid229)());
}

static STATUS hid230(){
return p_notexactly0('/');
}
STATUS NOTASLASH(){
PARSER hid230;
return((TOPARSER hid230)());
}

static STATUS hid231(){
return p_exactly0(';');
}
STATUS SEMICOLON(){
PARSER hid231;
return((TOPARSER hid231)());
}

static STATUS hid232(){
return p_exactly0('.');
}
static STATUS hid233(){
return p_exactly0('.');
}
static STATUS hid234(){
return p_exactly0('.');
}
static STATUS hid235(){
PARSER hid233, hid234;
static STATUS p_tok;
P_PAND((TOPARSER hid233)(),(TOPARSER hid234)());
return p_tok;
}
static STATUS hid236(){
PARSER hid232, hid235;
static STATUS p_tok;
P_PAND((TOPARSER hid232)(),(TOPARSER hid235)());
return p_tok;
}
static VOID hid237(){
 VV(3) = V(1);
}
static STATUS hid238(){
PARSER hid236;ACTION hid237;
return p_attach0n(TOPARSER hid236,0,hid237,0);
}
STATUS ELLIPSIS(){
PARSER hid238;
return((TOPARSER hid238)());
}



/*   finis   */


